SystemOrganization addCategory: #FuelCommandLineHandler!

CommandLineHandler subclass: #FuelCommandLineHandler
	instanceVariableNames: 'sourceFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelCommandLineHandler'!

!FuelCommandLineHandler class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/15/2012 13:03'!
commandName
	^ 'fuel'! !

!FuelCommandLineHandler class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 5/15/2012 13:03'!
description
	^ 'handles .fuel package files'! !

!FuelCommandLineHandler class methodsFor: 'handler selection' stamp: 'MarianoMartinezPeck 5/15/2012 13:36'!
isResponsibleFor: aCommandLine
	"This handler is reponsible only for .fuel files"
	(aCommandLine hasFileWithExtension: '.fuel')
		ifTrue: [ ^ true ].
	^ super isResponsibleFor: aCommandLine! !

!FuelCommandLineHandler methodsFor: 'activation' stamp: 'MarianoMartinezPeck 5/15/2012 13:04'!
activate
	self loadSourceFiles: (self commandLine allFilesWithExtension: 'fuel').
	self installSourceFiles.
	(self commandLine hasOption: 'quit')
		ifTrue: [ self exitSucess ].! !

!FuelCommandLineHandler methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/15/2012 13:02'!
handleError: error reference: aReference
	"Print a header before failing on an errro / syntax notification from the the script loaded by the given request"
	|stderr|
	
	"spit out a warning if in headless mode, otherwise a debugger will popup"
	Smalltalk isHeadless 
		ifTrue: [ self inform: 'Errors in script loaded from ', aReference fullName ].
																														
	(error isKindOf: SyntaxErrorNotification)
		"for syntax errors we can used the default action"
		ifTrue: [ error defaultAction ]
		"otherwise resignal it"
		ifFalse: [ error pass ]! !

!FuelCommandLineHandler methodsFor: 'installing' stamp: 'MarianoMartinezPeck 5/22/2012 17:54'!
installSourceFile: aReference
	"Install the previously loaded source file"

	| timeToMaterialize package timeToLoad bytes |
	aReference readStreamDo: [ :stream |
		FileStream stdout nextPutAll: 'Materializing package from file: ', aReference fullName; lf.
		bytes := (FileStream readOnlyFileNamed: aReference fullName) binary size asBytesDescription.
		timeToMaterialize := [package := FLPackageLoader new materializeFrom: (FileStream readOnlyFileNamed: aReference fullName) binary] timeToRun.
		FileStream stdout nextPutAll: 'Time to materialize: ', timeToMaterialize asString, ' miliseconds and occupied: ', bytes; lf.
		].
	FileStream stdout nextPutAll: 'Loading and initializing package from file: ', aReference fullName; lf.
	timeToLoad := [package load] timeToRun.
	FileStream stdout nextPutAll: 'Time to load: ', timeToLoad asString, 'miliseconds.'; lf.
	 
	! !

!FuelCommandLineHandler methodsFor: 'installing' stamp: 'MarianoMartinezPeck 5/15/2012 13:02'!
installSourceFiles
	"Install the previously loaded source files"

	sourceFiles ifNil: [ ^self ].
	[ sourceFiles do: [ :reference | self installSourceFile: reference ] ]
	ensure: [ sourceFiles := nil ].
	! !

!FuelCommandLineHandler methodsFor: 'loading' stamp: 'MarianoMartinezPeck 5/15/2012 13:02'!
loadSourceFiles: anArray
	"Load all the source files in the given array."

	sourceFiles := anArray collect: [ :each | 
						(FileSystem disk resolve: each) asFileReference ].
! !
